/*
 * $Id: blmvm.h,v 1.1 2004/07/26 13:10:55 tsuruoka Exp $
 */

/*
 * this file is a slightly modified version of blmvm.c by Steven J. Benson
 * downloaded from  http://www-unix.mcs.anl.gov/~benson/blmvm/
 */

#ifndef __BLMVM_H_
#define __BLMVM_H_

struct  _P_BLMVMVec{
  int    dim;
  double *val;
};

typedef struct _P_BLMVMVec *BLMVMVec;

struct  _P_LMVMMat{

  int lm;
  int lmnow;
  int iter;
  int rejects;

  double eps;

  BLMVMVec *S;
  BLMVMVec *Y;
  BLMVMVec Gprev;
  BLMVMVec Xprev;

  double y0normsquared;
  double *rho;
  double *beta;
};

typedef struct  _P_LMVMMat *LMVMMat;

struct  P_BLMVM{

  LMVMMat  M;

  BLMVMVec DX;
  BLMVMVec GP;
  BLMVMVec G;
  BLMVMVec XL;
  BLMVMVec XU;
  BLMVMVec Xold;

  int pgits;

};

typedef struct  P_BLMVM *BLMVM;

#endif

/*
 * $Log: blmvm.h,v $
 * Revision 1.1  2004/07/26 13:10:55  tsuruoka
 * add files
 *
 * Revision 1.1  2004/07/02 09:15:36  tsuruoka
 * add LMVM
 *
 */

